"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.METLO_ENABLED = exports.addToMaxChunkSize = exports.getDependencies = void 0;
const node_path_1 = __importDefault(require("node:path"));
const fs_1 = __importDefault(require("fs"));
const findClosestPackageJson = (dirPath) => {
    const filePath = node_path_1.default.join(dirPath, "package.json");
    if (!fs_1.default.existsSync(filePath)) {
        return findClosestPackageJson(dirPath.split("/").slice(0, -1).join("/"));
    }
    else {
        const data = JSON.parse(fs_1.default.readFileSync(filePath).toString("utf-8"));
        return data;
    }
};
const findParentPackage = () => {
    const moduleParent = require.main;
    return findClosestPackageJson(moduleParent.path);
};
const getDependencies = () => {
    return Object.keys(findParentPackage().dependencies);
};
exports.getDependencies = getDependencies;
const addToMaxChunkSize = (chunks, newChunks, maxSize) => {
    const existingSize = chunks.reduce((acc, curr) => acc + Buffer.byteLength(curr), 0);
    if (existingSize < maxSize) {
        let subBuffer = newChunks.subarray(0, maxSize - existingSize);
        chunks.push(subBuffer);
    }
};
exports.addToMaxChunkSize = addToMaxChunkSize;
const METLO_ENABLED = () => {
    return (process.env.METLO_ENABLE === undefined ||
        process.env.METLO_ENABLE === "true" ||
        process.env.METLO_ENABLE === "yes" ||
        process.env.METLO_ENABLE === "1");
};
exports.METLO_ENABLED = METLO_ENABLED;
//# sourceMappingURL=index.js.map