"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Logger = void 0;
const winston_1 = __importDefault(require("winston"));
let _logger = undefined;
const metloFormat = winston_1.default.format.printf(({ level, message, service, timestamp }) => {
    return `\[${timestamp} ${level} ${service}\]: ${message}`;
});
const levelMap = {
    trace: 4,
    debug: 3,
    info: 2,
    warn: 1,
    error: 0,
};
const Logger = (level) => {
    if (_logger)
        return _logger;
    else {
        const _level = level ? level : "error";
        let a = winston_1.default.addColors({
            error: "red",
            debug: "blue",
            warn: "yellow",
            info: "green",
            trace: "magenta",
        });
        _logger = winston_1.default.createLogger({
            levels: levelMap,
            level: levelMap[level],
            format: winston_1.default.format.combine(winston_1.default.format(info => {
                info.level = info.level.toUpperCase();
                return info;
            })(), winston_1.default.format.colorize(), winston_1.default.format.timestamp(), metloFormat),
            defaultMeta: { service: "metlo" },
            transports: [
                new winston_1.default.transports.Console({
                    level: _level,
                }),
            ],
        });
        return _logger;
    }
};
exports.Logger = Logger;
//# sourceMappingURL=logger.js.map